#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sat Jan  9 14:11:17 2021

@author: wor
"""
# choose one: 
global ORANGE_STICK ; ORANGE_STICK  = False                                     # the USB stick
global MBP_288      ; MBP_288       = True                                      # the Fraunhofer MacBook
global AAA_DWOR     ; AAA_DWOR      = False                                     # The AAA/CCC MacBook
if ORANGE_STICK:
    rootDirectory  = '/volumes/DRWORANGE32/COVID-19/'
elif MBP_288:
    rootDirectory  = '/Users/wor/documents/RESEARCH projects/COVID-19/'
elif AAA_DWOR:
    rootDirectory  = '/Users/davidworrall/Documents/RESEARCH/COVID-19/'
else:
    print ('\n ======== ROOT DIRECTORY NOT FOUND FOR COVID-19 PROJECT ======\n')
    
websiteDirectory = rootDirectory + 'website/'                                     #  for website
imageDirectory  = rootDirectory + 'graphImages/deaths_global/'                   # for non-website images
dataDirectory   = rootDirectory + 'dataSets/'                                    # root directory  for data


#  table template with Yattag

from yattag import Doc
doc, tag, text, line = Doc().ttl()   # equiv to doc = Doc(); tag = doc.tag; text = doc.text etc

#from covid19plotting import colorBreakpoints                                   # why does this run the plotting routine
from colorTables import colorBreakpoints


colorBreakpoints = [(10,     'tab:purple',  '#9467bd'),                             # defined in matplotlib.colors.TABLEAU_COLORS
                    (50,     'tab:blue',    '#1f77b4'),
                    (100,    'tab:cyan',    '#17becf'),
                    (200,    'tab:green',   '#2ca02c'),
                    (500,    'darkgoldenrod','#B8860B'),
                    (1000,   'tab:olive',   '#bcbd22'),
                    (1500,   'darkorange',  '#FF8C00'),
                    (2000,   'firebrick',   '#B22222'),
                    (10000,  'tab:red',     '#d62728')                          # any rediculously high number (not used)
                    ]




def getTableColors(breakpoints=colorBreakpoints):
    # sets up the matplotlib legend table to itemize (by default) a color table
    # of max deaths/day - as set in the colorBreakpoints list
    legendColors = []
    legendLabels = []
    lowerLimit = 0                                                            # charts not generated for 0 deaths
    for indx in range (len (breakpoints)):
        legendColors += [colorBreakpoints[indx][2]]                         
        legendLabels += [str(lowerLimit+1)+' to ' + str(colorBreakpoints[indx][0])] # the lower limit of this color's range
        lowerLimit = breakpoints[indx][0]
        if indx == len (breakpoints) -1:                                       # kluge to change last label
            legendLabels[-1] = str (breakpoints[-2][0]+1)+' & above'
    return legendColors, legendLabels

legendColors, legendLabels = getTableColors()

       #    maxLabelLen = len(max (legendLabels, key=len))                             # the longest label text
#print ("legendColors:", legendColors)
#print ("legendLabels:", legendLabels)
def makeColorTable():
    with tag ('table',  border="1px", style="background-color:#FFFFFF;"):
        with tag ('caption'):
            text ("Table of color-codes for max. nr. deaths/days.")
        with tag('tr'):
            with tag ('th'):
                text('Color')
            with tag ('th'):
                text ('Max. Daily Death rate')
        
        for colorNr in range (len (colorBreakpoints)):
            with tag ('tr'):
                with tag('td', width='70', style="background-color:"+legendColors[colorNr]+";"):
                    pass #text(str(colorNr))
                with tag('td', width='70', style="text-align:right;"):
                    text ( legendLabels[colorNr])

    
doc.asis ('<!DOCTYPE html>')
doc.asis('\n')
with tag('html'):
    doc.asis('\n')
    with tag ('head'):
        doc.asis('\n')
        with tag ('title'):
            text('COVID-19 Perceptualization')
        doc.asis('\n')
        with tag('style'):
            text('\n')
            text('body {'
                    +'\nbackground-color: #f0f8f0;'
                    +'\ncolor: black;'
                    + 'font-size:12px;'
                    + 'width: 900px;'
                    + 'topmargin: 0;' 
                    + 'leftmargin: 0;' 
#                    + 'height:480px;'
#                    + 'style=font-size:12px; color:red; font-weight:normal; font-style:plain; color: rgb(1, 1, 1);'
#                    +'background-color: rgb(88, 88,88;'
                    + 'marginheight:0; marginwidth:0;'
                    + 'text-decoration:none;'
                    + '}'
                    )
    doc.asis('\n')
    with tag('body'):
        with tag('p'):
            text("hello world!")
#        with tag ('table',  border = "2px",  "background-color:blue;"): 
        with tag ('table',  border="2px", style="background-color:#FFFFFF;"): 
            # cellpadding :1; cellspacing:1; width: 900;height: 400;"):
            with tag ('tr'):
                with tag('td', width='300', style="background-color:#FF0000;"):
                    with tag ('p'): 
                        text(" Upper Left colum")
                with tag('td', width='300'):
                    with tag ('p'):
                        text(" Upper Center colum")
                with tag('td', width='300'):
                    with tag ('p'):
                        text(" Upper Right colum")
            with tag ('tr'):
                with tag('td', width='300'):
                    with tag ('p'):
                        text(" Lower Left colum")
                with tag('td', width='300'):
                    with tag ('p'):
                        text(" Lower Center colum")
                with tag('td', width='300'):
                    with tag ('p'):
                        text(" Lower Right colum")
        makeColorTable()


    with tag ('a', href="./index.html", style="color: red"): 
        text ('HOME page red')
    with tag ('a', href="./index.html", style="color: blue"): 
        text ('HOME blue')
    with tag('p',  style="color: #000000"):
        text("Now is the time...")
            



testpage = open (websiteDirectory+'testpage.html', 'w')
testpage.write (doc.getvalue())
testpage.close()
